#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include "LEPC.h"

//Auto running time (sec.)
#define RUN_TIME 30

// Datafile pointer and glovals
FILE *gDataFile;
int SDcount;
int RDcount;
const char * runfname = "tmp.dat";
/// User defined dump format ///

void PrintNbytes(int t){
	if((gDataFile = fopen(runfname, "a+")) == NULL){
		printf("cannot open datafile %s \n",runfname);
		return;
	}
	fprintf(gDataFile, "%d\t%d\t%d\n", t, SDcount, RDcount);
	SDcount = 0;
	RDcount = 0;
	//	fflush(gDataFile);
	fclose(gDataFile);
}


// ********************************************************
// ** CallBack
// ********************************************************
void CallBackFunc(void *Buf, int datasize)
{
	int i;
	LE_MONDATAFORMAT1 *data = (LE_MONDATAFORMAT1 *)Buf;

	for( i = 0; i < datasize/(int)sizeof(LE_MONDATAFORMAT1); i ++ ){
		// data
		if(data[i].statusSD & LE_MONSTATUS_DATA_VISIBLE )
			SDcount ++;
		
		if(data[i].statusRD & LE_MONSTATUS_DATA_VISIBLE )
			RDcount ++;		
	}
}

// controls //

int Start()
{
	if( LEStartOnlineCallBack(CallBackFunc, 1) == LE_FAIL ){
		return -1;
		printf("LEStartOnlineCallBack failed\n");
	}
	printf("LEStartOnlineCallBack success\n");
	return 0;
}

int Stop()
{
	LEStop();
	printf("LEStop\n");
	return 0;
}

// user functions //

int StartRun(){

	int i;
	
	if(Start() == -1) return -1;
	
	if((gDataFile = fopen(runfname, "w+")) == NULL){
		printf("cannot open datafile %s \n",runfname);
		return -1;
	}
	
	printf("Data file name = %s\n\n",runfname);

	fclose(gDataFile);
	
	// reset counter
	SDcount = 0;
	RDcount = 0;
	
	for(i=0; i<RUN_TIME; i++){
		sleep(1);
		printf("\r%02d / %d sec. elapsed", i+1, RUN_TIME);
		fflush(stdout);
		PrintNbytes(i+1);
	}
	
	Stop();
	
	return 0;
}

int main(int argc, char *argv[])
{
	int i;
	
	if( argc != 2 ){
		printf("usage : PlotTest <serial number>\n");
		return 0;
	}

	// connect
	if( LEConnect(argv[1]) == LE_FAIL ) 	{
		printf("LEConnect failed\n");
		return -1;
	}
	printf("LEConnect %s\n",argv[1]);

	usleep(500000);
	
	// start run
	printf("Run Start\n");
	if(StartRun("tmp.dat") != 0){
		printf("start run failed\n");
	}

	LEDisconnect();
	return 0;
}
